#ifndef IMAGE_H
#define IMAGE_H

#define MAX_PATH 260

void planar422p_to_yuy2(  unsigned char *in, unsigned char *out, int width, int height);

/** image information
 *  @param stride width * pixel size
 *  @param width width of image (bytes)
 *  @param height height of image (bytes)
 */
typedef struct 
{
    int stride;
    int width;
    int height;
} image_info_t;

int save_image_uncompressed(const unsigned char *image, const char *szFilename, image_info_t *info, int type);
int yuy2_to_rgb_mem( const unsigned char *pin, unsigned char *pout, const unsigned char *pend, int stride);
int yuv2rgb_mem( const unsigned char *in, unsigned char *out, int height, int width);
void planar422p_to_yuv(  unsigned char *in, unsigned char *out, int width, int height);
int yuv2rgb565_mem( const unsigned char *in, unsigned char *out, int height, int width);
void planar422p_to_rgb565(  const unsigned char *in, unsigned char *out, int width, int height);
void planar422p_to_rgb8(  const unsigned char *in, unsigned char *out, int width, int height);
void grayscale_rgb565(  const unsigned char *in, unsigned char *out, int width, int height);
void grayscale_rgb565_mmx(  const unsigned char *in, unsigned char *out, int width, int height);
void grayscale_rgb24(  const unsigned char *in, unsigned char *out, int width, int height);
void grayscale_rgb32(  const unsigned char *in, unsigned char *out, int width, int height);
void planar422p_to_rgb32(  const unsigned char *in, unsigned char *out, int width, int height);
void planar422p_to_rgb24(  const unsigned char *in, unsigned char *out, int width, int height);

#endif

