// Copyright Sensoray Company Inc. 2007-2009
// Simple jpeg capture demo
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sched.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/mman.h>

#include "s2255.h"
#include "s2255f.h"
#include "s2255ioctl.h"

#define TCHAR char

#define _T(_x_)  _x_
#define MAX_PATH 260
#define TRUE 1

#define MAX_FRAME_WAIT 850  //(milliseconds)

HDEVICE hdev;
int board = 0;
int channel = 1;


//    CAPTURE function
int main()
{ 
    DWORD res;
    HANDLE hevent   ;
    int counter=0;
    TCHAR fname[MAX_PATH];
    int bJPEG = TRUE;
    int rc;
#define NUMFRAMES 8
#define MAX_JPG_SIZE (640*480*3)
    char *pbuf[NUMFRAMES];
    int i;
    BUFFER m_buf;

    if ((rc = S2255_DeviceOpen(board, &hdev)) != 0) {
        printf(_T("Error opening Device Error Num %d\n"), rc);
        exit(0);
    }
    m_buf.dwFrames = NUMFRAMES;

    for( i=0;i<NUMFRAMES;i++) {
        getbuf_param_t cmd;        
        cmd.idx = 0;
        cmd.frm_num = i;
        ioctl(hdev,S2255_IOC_REQBUF, &cmd);
        m_buf.frame[i].pdata = (char *)mmap(0, MAX_JPG_SIZE, PROT_READ, MAP_PRIVATE, hdev, (off_t) cmd.pbuf);
        if (m_buf.frame[i].pdata == NULL) {
            printf("mmap failed\n");
            return 0;
        }
    }

#define SINGLE                  0   // continuously (==0)
    MODE2255 mymode = { FORMAT_NTSC , DEF_SCALE, COLOR_RGB, DEF_FDEC, DEF_BRIGHT, DEF_CONTRAST, DEF_SATURATION, DEF_HUE,SINGLE   } ;          // monochrome
    // use &mymode for mode  in S2255_SetMode(HANDLE hdev, int channel, MODE2255 *mode);
    
    mymode.color = COLOR_JPG | (50 << 8); // JPEG with quality of 50

    rc = S2255_SetMode( hdev,  channel, &mymode);
    if (rc != 0) {
        printf(_T("Failed to set mode\n"));
        return -1;
    }

    // find out what size of buffer we need
    int im_size;
    int ee;
    for (i = 0; i < 5; i++) {
        rc = S2255_StartAcquire ( hdev,  channel, NULL);
        if (rc != 0) {
            printf(_T("Failed to start acquisition\n"));
            break;
        }
        for ( ee = 0; ee < 640; ee++){
            int drv_frame, cur_size;
            // The "event" is actually a semaphore.  So no frames will ever be missed.
            // But it is possible to spend too much time holding the buffer.  EG S2255_DQBUF
            // should be called fairly soon after the wait is done
            if (S2255_check_frame_block(hdev, channel, 1000, &drv_frame,
                                        &cur_size) != 0) {
                printf(_T("timed out!\n"));
                usleep(1000);
                continue;
            }
            // use the buffer 
            // in this example we save every 10 frames
            if (ee %10 == 0) {
                FILE *file;
                sprintf(fname, _T("buffer%d.jpg"), counter++);
                file = fopen(fname, "wb+");
                if (file != NULL) {
                    fwrite(m_buf.frame[drv_frame].pdata,
                           1,
                           cur_size,
                           file);
                    printf("wrote %d\n", cur_size);
                    fclose(file);
                }
                printf(_T("saved file %s\n"), fname);
            }

            S2255_DQBUF( hdev, channel, drv_frame++);
            if (drv_frame == m_buf.dwFrames) {
                drv_frame = 0;
            }
        }   
        S2255_StopAcquire(  hdev, channel);
    }
    // done.  close the device and SDK cleanly
    S2255_DeviceClose(hdev);
}

