#ifndef _S2255_H
#define _S2255_H

#include "s2255.h"

// pipes/endpoints 
// write pipe EP2( pipe 1 of 2)  512, 4x buffered
#define INDEX_WRITE_PIPE 0
// read pipe EP6 (pipe 2 of 2)   512, 4x buffered
#define INDEX_READ_PIPE  1
int s2255_lock_command(void *pdx);
int s2255_unlock_command(void *pdx);
int s2255_set_fwready( void *obj);
LONG s2255_write_config(PVOID pdx, UINT8 *pBuffer, SINT32 size);
LONG s2255_reset_pipe(PVOID pdx, UINT32 PipeNum);
LONG s2255_abort_pipe(PVOID pdx, UINT32 PipeNum);
LONG s2255_init_usbbus(PVOID pdx);
LONG s2255_uninit_usbbus(PVOID pdx);
int s2255_start_readpipe(PVOID pdx, UINT32 PipeID);
PVOID s2255_GetPipeHandle(PVOID pdx, int index);
void s2255_stop_readpipe(PVOID pdx);

int s2255_set_setmode( void *obj, int chn);
int s2255_wait_setmode( void *obj, int chn);

LONG s2255_vendor_request( PVOID pdx, UCHAR Request, UINT16 Index, UINT16 Value,
                               PVOID TransferBuffer, UINT32 TransferBufferLength, int Dir);

int	s2255_I2C_ReadRegister(PVOID pdx, UCHAR dev_addr, UINT16 reg_addr, UCHAR *reg_value );
int	s2255_I2C_WriteRegister(PVOID pdx, UCHAR dev_addr, UINT16 reg_addr, UCHAR reg_value );
int	s2255_I2C_WriteReg2(PVOID pdx, UCHAR dev_addr, UCHAR datalen, UCHAR *data );
int	s2255_I2C_WriteReg3(PVOID pdx, UCHAR dev_addr, UCHAR datalen, UCHAR *data );

int	s2255_I2C_ReadReg2(PVOID pdx, UCHAR dev_addr, UINT8 datalen, UCHAR *data );
int	s2255_I2C_ReadRegisterBurst(PVOID pdx, UCHAR dev_addr, UINT16 reg_addr, UCHAR *data, UCHAR datalen ) ;


//NTSTATUS	s2255_ioctl		( PDEVICE_EXTENSION pdx, ULONG cmd, PVOID pdin, ULONG cbin, PVOID pdout, ULONG cbout, PULONG pcbret );


int s2255_reset_frames( PVOID board, int channel);
int s2255_wait_multiple_events( PVOID obj[], ULONG count, int timeout);

int s2255_copy_kernel_to_user(char *pdest, char *psrc, int num_bytes);


void *s2255_alloc_mem(int size);
void s2255_free_mem(void *p);
// allocate continuous(dma-able) memory
void *s2255_alloc_dma_mem( int size ) ;
void s2255_free_dma_mem(void *p);
int s2255_memcpy(void *pDest, void *pSrc, UINT32 length);
int s2255_memcmp(void *pDest, void *pSrc, UINT32 length);
void s2255_memset(void *p, UINT32 length, UINT8 fill);
void s2255_sleep(int ms);
int s2255_readfile(char *filename, UINT8 *buf, int *readlen );
int s2255_lock_buffer( char *pToLock, ULONG num_bytes, char **pLocked, PVOID *pMDL);
int s2255_unlock_buffer(PVOID pMDL);


int s2255_wakeup( void *obj, int chn);

// print level  constants 
#define PRINT_ALWAYS				    0xFFFFFFFFL
#define PRINT_BUS	        		    0x00000001L
#define PRINT_DEVICE					0x00000002L
#define PRINT_I2C						0x00000004L
#define PRINT_MISC           		    0x00000008L

#ifdef WIN32
static int printlvl = -1;
#include "driver.h"
NTSTATUS s2255_ioctl	( PDEVICE_EXTENSION pdx, ULONG cmd, PVOID pdin, ULONG cbin, PVOID pdout, ULONG cbout, PULONG pcbret );
#define s2255_print(flags, _x_)	if( (flags) & printlvl ) {  DbgPrint("sx2255: "); DbgPrint _x_;	}
#elif defined _LINUX
#include <linux/kernel.h>
#define s2255_print(flags, _x_)	if( 1 ) {  printk("sx2255: "); printk _x_;	}
#endif

void * s2255_alloc_vmem( unsigned long size);
void s2255_free_vmem(void *mem, unsigned long size);
int s2255_set_vidstatus( void *obj, int chn);
int s2255_wait_vid_status(PVOID pdx, int chn);

#endif //_S2246_H
